#include<stdio.h>
#include<stdlib.h>

void imprimirSeparador();
void imprimirOpciones();
void nuevoContacto();
void imprimirContactos();
void imprimirContactosLetra();
void buscarContactosNombre();
void buscarContactosTelefono();
void eliminarContactoNombre();
void eliminarTodosContactos();    
... nuevoContactoLista(...);
... imprimirContactosLetraLista(...);
... buscarContactosNombreLista(...);
... buscarContactosTelefonoLista(...);
... eliminarContactoNombreLista(...);
... eliminarTodosContactosLista(...);
       

int main() {

    int opcion;

    while(1) { 
        
        imprimirOpciones();
        
        scanf("%d", &opcion);
        
        switch(opcion) {
        
            case 1:
                nuevoContacto();
                break;
            case 2:
                imprimirContactos();
                break;
            case 3:
                imprimirContactosLetra();
                break;
            case 4:
                buscarContactosNombre();
                break;
            case 5:
                buscarContactosTelefono();
                break;
            case 6:
                eliminarContactoNombre();
                break;
            case 7:
                eliminarTodosContactos();
                break;
            case 8:
                //liberar memoria antes de salir
                return 0; 
            default:
                break;
        }
    }
}

void imprimirSeparador() { printf("=================================\n"); }

void imprimirOpciones() {
    
    imprimirSeparador();
    printf("Agenda\n");
    printf("======\n");
    printf("1. Agregar contacto\n");
    printf("2. Mostrar contactos\n");
    printf("3. Mostrar contactos por letra\n");
    printf("4. Buscar contactos por nombre\n");
    printf("5. Buscar contactos por teléfono\n");
    printf("6. Eliminar contacto por nombre\n");
    printf("7. Eliminar todos los contactos\n");
    printf("8. Salir\n");
    imprimirSeparador();    
}

//se encarga de leer nombre, teléfono, mail y dirección del contacto que se desea agregar,
//llama a nuevoContactoLista(...) para agregarlo a la lista de ser posible y
//finalmente comunica al usuario el resultado de la operación
void nuevoContacto(){...}

//imprime la información de todos los contactos
void imprimirContactos(){...}

//lee la letra con que se quiere que empiecen los nombres de los contactos que se desean imprimir,
//luego le pasa el caracter a la función encargada de imprimirlos
void imprimirContactosLetra(){...}

//lee el nombre (o el inicio del mismo) que desea usarse para la búsqueda y se lo pasa a la función encargada de buscar
void buscarContactosNombre(){...}

//lee el teléfono (o el inicio del mismo) que desea usarse para la búsqueda y se lo pasa a la función encargada de buscar
void buscarContactosTelefono(){...}

//lee el nombre del contacto que se desea eliminar, solicita la confirmación del usuario,
//llama a eliminarContactoNombreLista(...) la cual borra el contacto si es que existe y
//finalmente comunica al usuario el resultado de la operación 
void eliminarContactoNombre(){...}

//solicita la confirmación del usuario antes de borrar todos los contactos,
//en caso de obtenerla llama a eliminarTodosContactosLista(...) y
//finalmente muestra un mensaje apropiado
void eliminarTodosContactos(){...}           

//recibe como argumento nombre, teléfono, mail y dirección del contacto que se desea agregar,
//si no existe ningún otro contacto con el mismo nombre lo agrega a la lista
... nuevoContactoLista(...){...}

//recibe un caracter e imprime todos los contactos cuyo nombre empieza con ese caracter
... imprimirContactosLetra(...){...}

//recibe una cadena de caracteres y devuelve los contactos cuyo nombre comienza con dicha cadena
//aclaración: NO debe diferenciar mayúsculas de minúsculas
... buscarContactosNombreLista(...){...}

//recibe un teléfono (o parte de él) y devuelve los contactos cuyo teléfono empieza con ese número
... buscarContactosTelefonoLista(...){...}

//recibe un nombre, si existe algún contacto en la lista con ese nombre lo borra
... eliminarContactoNombreLista(...){...}

//se encarga de borrar todos los nodos de la lista
... eliminarTodosContactosLista(...){...}
